module dmd.ModAssignExp;

import dmd.BinExp;
import dmd.Loc;
import dmd.Expression;
import dmd.Scope;
import dmd.InterState;
import dmd.OutBuffer;
import dmd.ArrayTypes;
import dmd.Identifier;
import dmd.IRState;
import dmd.TOK;

import dmd.backend.elem;

class ModAssignExp : BinExp
{
    this(Loc loc, Expression e1, Expression e2)
	{
		super(loc, TOK.TOKmodass, this.sizeof, e1, e2);
	}
	
    Expression semantic(Scope sc)
	{
    		return commonSemanticAssign(sc);
	}
	
    Expression interpret(InterState* istate)
	{
		assert(false);
	}
	
    void buildArrayIdent(OutBuffer buf, Expressions arguments)
	{
		assert(false);
	}
	
    Expression buildArrayLoop(Arguments fparams)
	{
		assert(false);
	}

    Identifier opId()    /* For operator overloading */
	{
		assert(false);
	}

    elem* toElem(IRState* irs)
	{
		assert(false);
	}
}
